-- TB.Simulationen/Surfduckmodding --

TB_Matrix = {};

function TB_Matrix.prerequisitesPresent(specializations)
      return true;
end;
function TB_Matrix.initSpecialization()
end
function TB_Matrix.registerOverwrittenFunctions(vehicleType)
end
function TB_Matrix.registerFunctions(vehicleType)	
end
function TB_Matrix.registerEvents(vehicleType)
end
function TB_Matrix:registerActionEventsPlayer()
end
function TB_Matrix:registerActionEventsMenu()
end

function TB_Matrix:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	if isOnActiveVehicle then
		if self.TB_Matrix == nil then 
			self.TB_Matrix = {}
		else	
			self:clearActionEventsTable( self.TB_Matrix )
		end 
		for _,actionName in pairs({"Stop_Polizei","Bitte_Folgen","Achtung_Schwerlast"}) do
			local _, eventName = self:addActionEvent(self.TB_Matrix, InputAction[actionName], self, TB_Matrix.actionCallback, true, true, false, true, nil);
	
			if isSelected then
				g_inputBinding.events[eventName].displayPriority = 1
			end
		end
	end
end

function TB_Matrix.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", TB_Matrix)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", TB_Matrix)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", TB_Matrix)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", TB_Matrix)
    --SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", TB_Matrix)
    --SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", TB_Matrix)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", TB_Matrix)
	SpecializationUtil.registerEventListener(vehicleType, "onDeactivate", TB_Matrix)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", TB_Matrix)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", TB_Matrix)
end

function TB_Matrix:onLoad(vehicle)	
	self.Stop_Polizei = TB_Matrix.Stop_Polizei
	self.Bitte_Folgen = TB_Matrix.Bitte_Folgen
	self.Achtung_Schwerlast = TB_Matrix.Achtung_Schwerlast
	self.RidelleAR = false
	self.RidelleG = false
	self.RidelleD = false
	
end;

function TB_Matrix:onDelete() 
end;
function TB_Matrix:onReadStream(streamId, connection)   
end;  
function TB_Matrix:onWriteStream(streamId, connection)  
end;
function TB_Matrix:mouseEvent(posX, posY, isDown, isUp, button)
end;
function TB_Matrix:keyEvent(unicode, sym, modifier, isDown)    
end;
function TB_Matrix:onUpdate(dt, vehicle)		
end;
function TB_Matrix:onUpdateTick() 
end;	
function TB_Matrix:onDeactivate()	
end;       
function TB_Matrix:onDraw()  
end;

function TB_Matrix:actionCallback(actionName, keyStatus, arg4, arg5, arg6)
	if keyStatus > 0 then
		if actionName == 'Stop_Polizei' then
			if self.RidelleAR then
				self:Stop_Polizei(false)
			else 
				self:Stop_Polizei(true)
			end
		end
		if actionName == 'Bitte_Folgen' then
			if self.RidelleG then
				self:Bitte_Folgen(false)
			else 
				self:Bitte_Folgen(true)
			end
		end
		if actionName == 'Achtung_Schwerlast' then
			if self.RidelleD then
				self:Achtung_Schwerlast(false)
			else 
				self:Achtung_Schwerlast(true)
			end
		end
	end
end

function TB_Matrix:Stop_Polizei(RidelleAR, noEventSend)
	Stop_PolizeiEvent.sendEvent(self, RidelleAR, noEventSend)
	self.RidelleAR = RidelleAR;
		if self.RidelleAR then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Stop_Polizei", 1, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Stop_Polizei", -1, nil, true)
			end
		end;
end;


function TB_Matrix:Bitte_Folgen(RidelleG, noEventSend)
	Bitte_FolgenEvent.sendEvent(self, RidelleG, noEventSend)
	self.RidelleG = RidelleG;
		if self.RidelleG then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Bitte_Folgen", 1, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Bitte_Folgen", -1, nil, true)
			end
		end;
end;

function TB_Matrix:Achtung_Schwerlast(RidelleD, noEventSend)
	Achtung_SchwerlastEvent.sendEvent(self, RidelleD, noEventSend)
	self.RidelleD = RidelleD;
		if self.RidelleD then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Achtung_Schwerlast", 1, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Achtung_Schwerlast", -1, nil, true)
			end
		end;
end;

--- Event ---

Stop_PolizeiEvent = {};
Stop_PolizeiEvent_mt = Class(Stop_PolizeiEvent, Event);
InitEventClass(Stop_PolizeiEvent, "Stop_PolizeiEvent");

function Stop_PolizeiEvent:emptyNew()
    local self = Event:new(Stop_PolizeiEvent_mt);
    return self;
end;
function Stop_PolizeiEvent:new(object, RidelleAR)
	local self = Stop_PolizeiEvent:emptyNew()
	self.object = object;
	self.RidelleAR = RidelleAR;
	return self;
end;
function Stop_PolizeiEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.RidelleAR = streamReadBool(streamId);
	self:run(connection);
end;
function Stop_PolizeiEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.RidelleAR);
end;
function Stop_PolizeiEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Stop_Polizei(self.RidelleAR, true);
	end;
end;
function Stop_PolizeiEvent.sendEvent(vehicle, RidelleAR, noEventSend)
	if RidelleAR ~= vehicle.RidelleAR then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Stop_PolizeiEvent:new(vehicle, RidelleAR), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Stop_PolizeiEvent:new(vehicle, RidelleAR));
			end;
		end;
	end;
end;

Bitte_FolgenEvent = {};
Bitte_FolgenEvent_mt = Class(Bitte_FolgenEvent, Event);
InitEventClass(Bitte_FolgenEvent, "Bitte_FolgenEvent");

function Bitte_FolgenEvent:emptyNew()
    local self = Event:new(Bitte_FolgenEvent_mt);
    return self;
end;
function Bitte_FolgenEvent:new(object, RidelleG)
	local self = Bitte_FolgenEvent:emptyNew()
	self.object = object;
	self.RidelleG = RidelleG;
	return self;
end;
function Bitte_FolgenEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.RidelleG = streamReadBool(streamId);
	self:run(connection);
end;
function Bitte_FolgenEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.RidelleG);
end;
function Bitte_FolgenEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Bitte_Folgen(self.RidelleG, true);
	end;
end;
function Bitte_FolgenEvent.sendEvent(vehicle, RidelleG, noEventSend)
	if RidelleG ~= vehicle.RidelleG then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Bitte_FolgenEvent:new(vehicle, RidelleG), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Bitte_FolgenEvent:new(vehicle, RidelleG));
			end;
		end;
	end;
end;


Achtung_SchwerlastEvent = {};
Achtung_SchwerlastEvent_mt = Class(Achtung_SchwerlastEvent, Event);
InitEventClass(Achtung_SchwerlastEvent, "Achtung_SchwerlastEvent");

function Achtung_SchwerlastEvent:emptyNew()
    local self = Event:new(Achtung_SchwerlastEvent_mt);
    return self;
end;
function Achtung_SchwerlastEvent:new(object, RidelleD)
	local self = Achtung_SchwerlastEvent:emptyNew()
	self.object = object;
	self.RidelleD = RidelleD;
	return self;
end;
function Achtung_SchwerlastEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.RidelleD = streamReadBool(streamId);
	self:run(connection);
end;
function Achtung_SchwerlastEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.RidelleD);
end;
function Achtung_SchwerlastEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Achtung_Schwerlast(self.RidelleD, true);
	end;
end;
function Achtung_SchwerlastEvent.sendEvent(vehicle, RidelleD, noEventSend)
	if RidelleD ~= vehicle.RidelleD then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Achtung_SchwerlastEvent:new(vehicle, RidelleD), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Achtung_SchwerlastEvent:new(vehicle, RidelleD));
			end;
		end;
	end;
end;